import { CreateUIAnalyticsEvent } from '@atlaskit/analytics-next';
import { Node as PMNode } from 'prosemirror-model';
import { Step, StepResult, StepMap, ReplaceStep } from 'prosemirror-transform';
import { AnalyticsEventPayloadWithChannel } from './types';
export declare const analyticsStepType = "atlaskit-analytics";
/**
 * Custom Prosemirror Step to fire our GAS V3 analytics events
 * Using a Step means that it will work with prosemirror-history and we get
 * undo/redo events for free
 */
export declare class AnalyticsStep extends Step {
    analyticsEvents: AnalyticsEventPayloadWithChannel[];
    createAnalyticsEvent: CreateUIAnalyticsEvent;
    constructor(createAnalyticsEvent: CreateUIAnalyticsEvent, analyticsEvents: AnalyticsEventPayloadWithChannel[]);
    /**
     * Generate new undo/redo analytics event when step is inverted
     */
    invert(): AnalyticsStep;
    apply(doc: PMNode): StepResult<any>;
    map(): null;
    getMap(): StepMap;
    toJSON(): {
        stepType: string;
    };
    static fromJSON(): ReplaceStep<any>;
}
