"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_components_1 = tslib_1.__importDefault(require("styled-components"));
var theme_1 = require("@atlaskit/theme");
var editor_common_1 = require("@atlaskit/editor-common");
exports.Header = styled_components_1.default.div(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  z-index: ", ";\n  min-height: 24px;\n  padding: 20px 40px;\n  font-size: 24px;\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  box-shadow: ", ";\n  color: ", ";\n  background-color: ", ";\n  border-radius: ", "px;\n"], ["\n  z-index: ", ";\n  min-height: 24px;\n  padding: 20px 40px;\n  font-size: 24px;\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  box-shadow: ",
    ";\n  color: ", ";\n  background-color: ", ";\n  border-radius: ", "px;\n"])), editor_common_1.akEditorUnitZIndex, function (props) {
    return props.showKeyline ? "0 2px 0 " + theme_1.colors.N30 : 'none';
}, theme_1.colors.N400, theme_1.colors.N0, theme_1.borderRadius());
exports.Footer = styled_components_1.default.div(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n  z-index: ", ";\n  font-size: 14px;\n  line-height: 20px;\n  color: ", ";\n  padding: 24px;\n  text-align: right;\n  box-shadow: ", ";\n"], ["\n  z-index: ", ";\n  font-size: 14px;\n  line-height: 20px;\n  color: ", ";\n  padding: 24px;\n  text-align: right;\n  box-shadow: ",
    ";\n"])), editor_common_1.akEditorUnitZIndex, theme_1.colors.N300, function (props) {
    return props.showKeyline ? "0 -2px 0 " + theme_1.colors.N30 : 'none';
});
exports.ContentWrapper = styled_components_1.default.div(templateObject_3 || (templateObject_3 = tslib_1.__makeTemplateObject(["\n  padding: 18px 20px;\n  border-bottom-right-radius: ", "px;\n  overflow: auto;\n  position: relative;\n  color: ", ";\n  background-color: ", ";\n"], ["\n  padding: 18px 20px;\n  border-bottom-right-radius: ", "px;\n  overflow: auto;\n  position: relative;\n  color: ", ";\n  background-color: ", ";\n"])), theme_1.borderRadius(), theme_1.colors.N400, theme_1.colors.N0);
exports.Line = styled_components_1.default.div(templateObject_4 || (templateObject_4 = tslib_1.__makeTemplateObject(["\n  background: #fff;\n  content: '';\n  display: block;\n  height: 2px;\n  left: 0;\n  position: absolute;\n  top: 0;\n  right: 0;\n  width: 100%;\n  min-width: 604px;\n"], ["\n  background: #fff;\n  content: '';\n  display: block;\n  height: 2px;\n  left: 0;\n  position: absolute;\n  top: 0;\n  right: 0;\n  width: 100%;\n  min-width: 604px;\n"])));
exports.Content = styled_components_1.default.div(templateObject_5 || (templateObject_5 = tslib_1.__makeTemplateObject(["\n  min-width: 524px;\n  width: 100%;\n  position: relative;\n  display: flex;\n  justify-content: space-between;\n"], ["\n  min-width: 524px;\n  width: 100%;\n  position: relative;\n  display: flex;\n  justify-content: space-between;\n"])));
exports.ColumnLeft = styled_components_1.default.div(templateObject_6 || (templateObject_6 = tslib_1.__makeTemplateObject(["\n  width: 44%;\n"], ["\n  width: 44%;\n"])));
exports.ColumnRight = styled_components_1.default.div(templateObject_7 || (templateObject_7 = tslib_1.__makeTemplateObject(["\n  width: 44%;\n"], ["\n  width: 44%;\n"])));
exports.Row = styled_components_1.default.div(templateObject_8 || (templateObject_8 = tslib_1.__makeTemplateObject(["\n  margin: 20px 0;\n  display: flex;\n  justify-content: space-between;\n"], ["\n  margin: 20px 0;\n  display: flex;\n  justify-content: space-between;\n"])));
exports.Title = styled_components_1.default.div(templateObject_9 || (templateObject_9 = tslib_1.__makeTemplateObject(["\n  font-size: 18px;\n  font-weight: 400;\n"], ["\n  font-size: 18px;\n  font-weight: 400;\n"])));
exports.CodeSm = styled_components_1.default.span(templateObject_10 || (templateObject_10 = tslib_1.__makeTemplateObject(["\n  background-color: ", ";\n  border-radius: ", "px;\n  width: 24px;\n  display: inline-block;\n  height: 24px;\n  line-height: 24px;\n  text-align: center;\n"], ["\n  background-color: ", ";\n  border-radius: ", "px;\n  width: 24px;\n  display: inline-block;\n  height: 24px;\n  line-height: 24px;\n  text-align: center;\n"])), theme_1.colors.N20, theme_1.borderRadius());
exports.CodeMd = styled_components_1.default.span(templateObject_11 || (templateObject_11 = tslib_1.__makeTemplateObject(["\n  background-color: ", ";\n  border-radius: ", "px;\n  display: inline-block;\n  height: 24px;\n  line-height: 24px;\n  width: 50px;\n  text-align: center;\n"], ["\n  background-color: ", ";\n  border-radius: ", "px;\n  display: inline-block;\n  height: 24px;\n  line-height: 24px;\n  width: 50px;\n  text-align: center;\n"])), theme_1.colors.N20, theme_1.borderRadius());
exports.CodeLg = styled_components_1.default.span(templateObject_12 || (templateObject_12 = tslib_1.__makeTemplateObject(["\n  background-color: ", ";\n  border-radius: ", "px;\n  display: inline-block;\n  height: 24px;\n  line-height: 24px;\n  padding: 0 10px;\n  text-align: center;\n"], ["\n  background-color: ", ";\n  border-radius: ", "px;\n  display: inline-block;\n  height: 24px;\n  line-height: 24px;\n  padding: 0 10px;\n  text-align: center;\n"])), theme_1.colors.N20, theme_1.borderRadius());
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12;
//# sourceMappingURL=styles.js.map