"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var compareNodes_1 = require("./compareNodes");
exports.compareNodes = compareNodes_1.compareNodes;
var selection_1 = require("./selection");
exports.getSelectedColumnIndexes = selection_1.getSelectedColumnIndexes;
exports.getSelectedRowIndexes = selection_1.getSelectedRowIndexes;
exports.normalizeSelection = selection_1.normalizeSelection;
exports.isSelectionUpdated = selection_1.isSelectionUpdated;
var decoration_1 = require("./decoration");
exports.findControlsHoverDecoration = decoration_1.findControlsHoverDecoration;
exports.createControlsHoverDecoration = decoration_1.createControlsHoverDecoration;
exports.createColumnControlsDecoration = decoration_1.createColumnControlsDecoration;
exports.createColumnSelectedDecorations = decoration_1.createColumnSelectedDecorations;
exports.createCellHoverDecoration = decoration_1.createCellHoverDecoration;
exports.updatePluginStateDecorations = decoration_1.updatePluginStateDecorations;
exports.updateNodeDecorations = decoration_1.updateNodeDecorations;
var nodes_1 = require("./nodes");
exports.isIsolating = nodes_1.isIsolating;
exports.containsHeaderColumn = nodes_1.containsHeaderColumn;
exports.containsHeaderRow = nodes_1.containsHeaderRow;
exports.checkIfHeaderColumnEnabled = nodes_1.checkIfHeaderColumnEnabled;
exports.checkIfHeaderRowEnabled = nodes_1.checkIfHeaderRowEnabled;
exports.checkIfNumberColumnEnabled = nodes_1.checkIfNumberColumnEnabled;
exports.isLayoutSupported = nodes_1.isLayoutSupported;
exports.getTableWidth = nodes_1.getTableWidth;
exports.tablesHaveDifferentColumnWidths = nodes_1.tablesHaveDifferentColumnWidths;
exports.tablesHaveDifferentNoOfColumns = nodes_1.tablesHaveDifferentNoOfColumns;
var paste_1 = require("./paste");
exports.unwrapContentFromTable = paste_1.unwrapContentFromTable;
exports.removeTableFromFirstChild = paste_1.removeTableFromFirstChild;
exports.removeTableFromLastChild = paste_1.removeTableFromLastChild;
exports.transformSliceToRemoveOpenTable = paste_1.transformSliceToRemoveOpenTable;
exports.transformSliceToCorrectEmptyTableCells = paste_1.transformSliceToCorrectEmptyTableCells;
exports.transformSliceToFixHardBreakProblemOnCopyFromCell = paste_1.transformSliceToFixHardBreakProblemOnCopyFromCell;
var dom_1 = require("./dom");
exports.isCell = dom_1.isCell;
exports.isCornerButton = dom_1.isCornerButton;
exports.isInsertRowButton = dom_1.isInsertRowButton;
exports.isColumnControlsDecorations = dom_1.isColumnControlsDecorations;
exports.isTableControlsButton = dom_1.isTableControlsButton;
exports.isRowControlsButton = dom_1.isRowControlsButton;
exports.getColumnOrRowIndex = dom_1.getColumnOrRowIndex;
exports.getMousePositionHorizontalRelativeByElement = dom_1.getMousePositionHorizontalRelativeByElement;
exports.getMousePositionVerticalRelativeByElement = dom_1.getMousePositionVerticalRelativeByElement;
exports.updateResizeHandles = dom_1.updateResizeHandles;
var column_controls_1 = require("./column-controls");
exports.getColumnsWidths = column_controls_1.getColumnsWidths;
exports.isColumnDeleteButtonVisible = column_controls_1.isColumnDeleteButtonVisible;
exports.getColumnDeleteButtonParams = column_controls_1.getColumnDeleteButtonParams;
exports.getColumnClassNames = column_controls_1.getColumnClassNames;
var row_controls_1 = require("./row-controls");
exports.getRowHeights = row_controls_1.getRowHeights;
exports.isRowDeleteButtonVisible = row_controls_1.isRowDeleteButtonVisible;
exports.getRowDeleteButtonParams = row_controls_1.getRowDeleteButtonParams;
exports.getRowsParams = row_controls_1.getRowsParams;
exports.getRowClassNames = row_controls_1.getRowClassNames;
exports.copyPreviousRow = row_controls_1.copyPreviousRow;
var analytics_1 = require("./analytics");
exports.getSelectedTableInfo = analytics_1.getSelectedTableInfo;
exports.getSelectedCellInfo = analytics_1.getSelectedCellInfo;
var table_1 = require("./table");
exports.getMergedCellsPositions = table_1.getMergedCellsPositions;
//# sourceMappingURL=index.js.map