import { ReactElement } from 'react';
import { InjectedIntl } from 'react-intl';
import { EditorState, Transaction } from 'prosemirror-state';
import { Node } from 'prosemirror-model';
import { SelectItemMode } from './commands/select-item';
import { Dispatch } from '../../event-dispatcher';
export declare type TypeAheadItemRenderProps = {
    onClick: () => void;
    onHover: () => void;
    isSelected: boolean;
};
export declare type TypeAheadItem = {
    title: string;
    description?: string;
    keyshortcut?: string;
    key?: string | number;
    icon?: () => ReactElement<any>;
    render?: (props: TypeAheadItemRenderProps) => React.ReactElement<TypeAheadItemRenderProps> | null;
    [key: string]: any;
};
export declare type TypeAheadInsert = (node?: Node | Object | string, opts?: {
    selectInlineNode?: boolean;
}) => Transaction;
export declare type TypeAheadSelectItem = (state: EditorState, item: TypeAheadItem, insert: TypeAheadInsert, meta: {
    mode: SelectItemMode;
}) => Transaction | false;
export declare type TypeAheadHandler = {
    trigger: string;
    customRegex?: string;
    forceSelect?: (query: string, items: Array<TypeAheadItem>) => boolean;
    getItems: (query: string, editorState: EditorState, intl: InjectedIntl, meta: {
        prevActive: boolean;
        queryChanged: boolean;
    }, tr: Transaction, dipatch: Dispatch) => Array<TypeAheadItem> | Promise<Array<TypeAheadItem>>;
    selectItem: TypeAheadSelectItem;
    dismiss?: (state: EditorState) => void;
    getHighlight?: (state: EditorState) => JSX.Element | null;
};
export declare type TypeAheadItemsLoader = null | {
    promise: Promise<Array<TypeAheadItem>>;
    cancel(): void;
};
