"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_components_1 = tslib_1.__importDefault(require("styled-components"));
var editor_common_1 = require("@atlaskit/editor-common");
var styles_1 = require("../../plugins/collab-edit/styles");
var styles_2 = require("../../plugins/gap-cursor/styles");
var styles_3 = require("../../plugins/table/ui/styles");
var styles_4 = require("../../plugins/placeholder/styles");
var styles_5 = require("../../plugins/block-type/styles");
var styles_6 = require("../../plugins/code-block/styles");
var styles_7 = require("../../plugins/lists/styles");
var styles_8 = require("../../plugins/rule/styles");
var styles_9 = require("../../plugins/media/styles");
var styles_10 = require("../../plugins/layout/styles");
var styles_11 = require("../../plugins/panel/styles");
var styles_12 = require("../../plugins/fake-text-cursor/styles");
var styles_13 = require("../../plugins/mentions/styles");
var styles_14 = require("../../plugins/text-formatting/styles");
var styles_15 = require("../../plugins/placeholder-text/styles");
var styles_16 = require("../../plugins/tasks-and-decisions/ui/styles");
var styles_17 = require("../../plugins/grid/styles");
var styles_18 = require("../../plugins/hyperlink/styles");
var styles_19 = require("../../plugins/extension/ui/styles");
var ContentStyles = styled_components_1.default.div(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  /* Hack for ie11 that is being used in code block.\n   * https://bitbucket.org/atlassian/atlaskit/src/ad09f6361109ece1aab316c8cbd8116ffb7963ef/packages/editor-core/src/schema/nodes/code-block.ts?fileviewer=file-view-default#code-block.ts-110\n   */\n  & .ie11 {\n    overflow: visible;\n    word-wrap: break-word;\n  }\n\n  .ProseMirror {\n    outline: none;\n    font-size: ", "px;\n\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n  }\n\n  .ProseMirror-hideselection *::selection {\n    background: transparent;\n  }\n\n  .ProseMirror-hideselection *::-moz-selection {\n    background: transparent;\n  }\n\n  .ProseMirror-selectednode {\n    outline: none;\n  }\n\n  .ProseMirror-selectednode:empty {\n    outline: 2px solid #8cf;\n  }\n\n  .inlineCardView-content-wrap {\n    max-width: calc(100% - 20px);\n    vertical-align: top;\n    word-break: break-all;\n  }\n\n  .inlineCardView-content-wrap .card {\n    padding-left: 2px;\n    padding-right: 2px;\n  }\n\n  .blockCardView-content-wrap {\n    display: inline-block;\n  }\n\n  /* fix cursor alignment */\n  .ProseMirror .emoji-common-node {\n    display: inline;\n    vertical-align: baseline;\n\n    img {\n      display: inline-block;\n      vertical-align: middle;\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", ";\n  ", ";\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n\n  /** Global selector for extensions, as .danger tag is assigned to root level node which is unaccessible from triggered child node **/\n  /* Danger when nested node */\n  .danger .extension-container {\n    background: rgb(255, 189, 173, 0.5); /* R75 with 50% opactiy */\n    transition: opacity 0s;\n  }\n\n  /* Danger when top level node */\n  .danger > span > .extension-container {\n    background: ", ";\n    box-shadow: 0 0 0 ", "px ", ";\n  }\n\n  .panelView-content-wrap {\n    box-sizing: border-box;\n  }\n\n  .mediaGroupView-content-wrap ul {\n    padding: 0;\n  }\n\n  /** Needed to override any cleared floats, e.g. image wrapping */\n  div.fabric-editor-block-mark[class^='fabric-editor-align'] {\n    clear: none !important;\n  }\n\n  .fabric-editor-align-end {\n    text-align: right;\n  }\n\n  .fabric-editor-align-start {\n    text-align: left;\n  }\n\n  .fabric-editor-align-center {\n    text-align: center;\n  }\n\n  .hyperlink-floating-toolbar {\n    padding: 0;\n  }\n\n  /* Link icon in the Atlaskit package \n     is bigger than the others\n  */\n  .hyperlink-open-link {\n    svg {\n      max-width: 18px;\n    }\n    &[href] {\n      padding: 0 4px;\n    }\n  }\n\n"], ["\n  /* Hack for ie11 that is being used in code block.\n   * https://bitbucket.org/atlassian/atlaskit/src/ad09f6361109ece1aab316c8cbd8116ffb7963ef/packages/editor-core/src/schema/nodes/code-block.ts?fileviewer=file-view-default#code-block.ts-110\n   */\n  & .ie11 {\n    overflow: visible;\n    word-wrap: break-word;\n  }\n\n  .ProseMirror {\n    outline: none;\n    font-size: ", "px;\n\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n  }\n\n  .ProseMirror-hideselection *::selection {\n    background: transparent;\n  }\n\n  .ProseMirror-hideselection *::-moz-selection {\n    background: transparent;\n  }\n\n  .ProseMirror-selectednode {\n    outline: none;\n  }\n\n  .ProseMirror-selectednode:empty {\n    outline: 2px solid #8cf;\n  }\n\n  .inlineCardView-content-wrap {\n    max-width: calc(100% - 20px);\n    vertical-align: top;\n    word-break: break-all;\n  }\n\n  .inlineCardView-content-wrap .card {\n    padding-left: 2px;\n    padding-right: 2px;\n  }\n\n  .blockCardView-content-wrap {\n    display: inline-block;\n  }\n\n  /* fix cursor alignment */\n  .ProseMirror .emoji-common-node {\n    display: inline;\n    vertical-align: baseline;\n\n    img {\n      display: inline-block;\n      vertical-align: middle;\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", ";\n  ", ";\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n\n  /** Global selector for extensions, as .danger tag is assigned to root level node which is unaccessible from triggered child node **/\n  /* Danger when nested node */\n  .danger .extension-container {\n    background: rgb(255, 189, 173, 0.5); /* R75 with 50% opactiy */\n    transition: opacity 0s;\n  }\n\n  /* Danger when top level node */\n  .danger > span > .extension-container {\n    background: ", ";\n    box-shadow: 0 0 0 ", "px ", ";\n  }\n\n  .panelView-content-wrap {\n    box-sizing: border-box;\n  }\n\n  .mediaGroupView-content-wrap ul {\n    padding: 0;\n  }\n\n  /** Needed to override any cleared floats, e.g. image wrapping */\n  div.fabric-editor-block-mark[class^='fabric-editor-align'] {\n    clear: none !important;\n  }\n\n  .fabric-editor-align-end {\n    text-align: right;\n  }\n\n  .fabric-editor-align-start {\n    text-align: left;\n  }\n\n  .fabric-editor-align-center {\n    text-align: center;\n  }\n\n  .hyperlink-floating-toolbar {\n    padding: 0;\n  }\n\n  /* Link icon in the Atlaskit package \n     is bigger than the others\n  */\n  .hyperlink-open-link {\n    svg {\n      max-width: 18px;\n    }\n    &[href] {\n      padding: 0 4px;\n    }\n  }\n\n"])), editor_common_1.editorFontSize, editor_common_1.whitespaceSharedStyles, editor_common_1.paragraphSharedStyles, editor_common_1.listsSharedStyles, editor_common_1.indentationSharedStyles, editor_common_1.shadowSharedStyle, editor_common_1.inlineNodeSharedStyle, styles_5.blocktypeStyles, styles_14.textFormattingStyles, styles_15.placeholderTextStyles, styles_4.placeholderStyles, styles_6.codeBlockStyles, styles_7.listsStyles, styles_8.ruleStyles, styles_9.mediaStyles, styles_10.layoutStyles, styles_1.telepointerStyle, styles_2.gapCursorStyles, styles_3.tableStyles, styles_11.panelStyles, styles_12.fakeCursorStyles, styles_13.mentionsStyles, styles_16.tasksAndDecisionsStyles, styles_17.gridStyles, styles_18.linkStyles, editor_common_1.blockMarksSharedStyles, editor_common_1.dateSharedStyle, styles_19.extensionStyles, editor_common_1.akEditorDeleteBackground, editor_common_1.akEditorSelectedBorderBoldSize, editor_common_1.akEditorDeleteBorder);
exports.default = ContentStyles;
var templateObject_1;
//# sourceMappingURL=index.js.map