import { __makeTemplateObject } from "tslib";
import styled from 'styled-components';
import { editorFontSize, whitespaceSharedStyles, paragraphSharedStyles, listsSharedStyles, indentationSharedStyles, blockMarksSharedStyles, shadowSharedStyle, inlineNodeSharedStyle, dateSharedStyle, akEditorDeleteBackground, akEditorDeleteBorder, akEditorSelectedBorderBoldSize, } from '@atlaskit/editor-common';
import { telepointerStyle } from '../../plugins/collab-edit/styles';
import { gapCursorStyles } from '../../plugins/gap-cursor/styles';
import { tableStyles } from '../../plugins/table/ui/styles';
import { placeholderStyles } from '../../plugins/placeholder/styles';
import { blocktypeStyles } from '../../plugins/block-type/styles';
import { codeBlockStyles } from '../../plugins/code-block/styles';
import { listsStyles } from '../../plugins/lists/styles';
import { ruleStyles } from '../../plugins/rule/styles';
import { mediaStyles } from '../../plugins/media/styles';
import { layoutStyles } from '../../plugins/layout/styles';
import { panelStyles } from '../../plugins/panel/styles';
import { fakeCursorStyles } from '../../plugins/fake-text-cursor/styles';
import { mentionsStyles } from '../../plugins/mentions/styles';
import { textFormattingStyles } from '../../plugins/text-formatting/styles';
import { placeholderTextStyles } from '../../plugins/placeholder-text/styles';
import { tasksAndDecisionsStyles } from '../../plugins/tasks-and-decisions/ui/styles';
import { gridStyles } from '../../plugins/grid/styles';
import { linkStyles } from '../../plugins/hyperlink/styles';
import { extensionStyles } from '../../plugins/extension/ui/styles';
var ContentStyles = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  /* Hack for ie11 that is being used in code block.\n   * https://bitbucket.org/atlassian/atlaskit/src/ad09f6361109ece1aab316c8cbd8116ffb7963ef/packages/editor-core/src/schema/nodes/code-block.ts?fileviewer=file-view-default#code-block.ts-110\n   */\n  & .ie11 {\n    overflow: visible;\n    word-wrap: break-word;\n  }\n\n  .ProseMirror {\n    outline: none;\n    font-size: ", "px;\n\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n  }\n\n  .ProseMirror-hideselection *::selection {\n    background: transparent;\n  }\n\n  .ProseMirror-hideselection *::-moz-selection {\n    background: transparent;\n  }\n\n  .ProseMirror-selectednode {\n    outline: none;\n  }\n\n  .ProseMirror-selectednode:empty {\n    outline: 2px solid #8cf;\n  }\n\n  .inlineCardView-content-wrap {\n    max-width: calc(100% - 20px);\n    vertical-align: top;\n    word-break: break-all;\n  }\n\n  .inlineCardView-content-wrap .card {\n    padding-left: 2px;\n    padding-right: 2px;\n  }\n\n  .blockCardView-content-wrap {\n    display: inline-block;\n  }\n\n  /* fix cursor alignment */\n  .ProseMirror .emoji-common-node {\n    display: inline;\n    vertical-align: baseline;\n\n    img {\n      display: inline-block;\n      vertical-align: middle;\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", ";\n  ", ";\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n\n  /** Global selector for extensions, as .danger tag is assigned to root level node which is unaccessible from triggered child node **/\n  /* Danger when nested node */\n  .danger .extension-container {\n    background: rgb(255, 189, 173, 0.5); /* R75 with 50% opactiy */\n    transition: opacity 0s;\n  }\n\n  /* Danger when top level node */\n  .danger > span > .extension-container {\n    background: ", ";\n    box-shadow: 0 0 0 ", "px ", ";\n  }\n\n  .panelView-content-wrap {\n    box-sizing: border-box;\n  }\n\n  .mediaGroupView-content-wrap ul {\n    padding: 0;\n  }\n\n  /** Needed to override any cleared floats, e.g. image wrapping */\n  div.fabric-editor-block-mark[class^='fabric-editor-align'] {\n    clear: none !important;\n  }\n\n  .fabric-editor-align-end {\n    text-align: right;\n  }\n\n  .fabric-editor-align-start {\n    text-align: left;\n  }\n\n  .fabric-editor-align-center {\n    text-align: center;\n  }\n\n  .hyperlink-floating-toolbar {\n    padding: 0;\n  }\n\n  /* Link icon in the Atlaskit package \n     is bigger than the others\n  */\n  .hyperlink-open-link {\n    svg {\n      max-width: 18px;\n    }\n    &[href] {\n      padding: 0 4px;\n    }\n  }\n\n"], ["\n  /* Hack for ie11 that is being used in code block.\n   * https://bitbucket.org/atlassian/atlaskit/src/ad09f6361109ece1aab316c8cbd8116ffb7963ef/packages/editor-core/src/schema/nodes/code-block.ts?fileviewer=file-view-default#code-block.ts-110\n   */\n  & .ie11 {\n    overflow: visible;\n    word-wrap: break-word;\n  }\n\n  .ProseMirror {\n    outline: none;\n    font-size: ", "px;\n\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n  }\n\n  .ProseMirror-hideselection *::selection {\n    background: transparent;\n  }\n\n  .ProseMirror-hideselection *::-moz-selection {\n    background: transparent;\n  }\n\n  .ProseMirror-selectednode {\n    outline: none;\n  }\n\n  .ProseMirror-selectednode:empty {\n    outline: 2px solid #8cf;\n  }\n\n  .inlineCardView-content-wrap {\n    max-width: calc(100% - 20px);\n    vertical-align: top;\n    word-break: break-all;\n  }\n\n  .inlineCardView-content-wrap .card {\n    padding-left: 2px;\n    padding-right: 2px;\n  }\n\n  .blockCardView-content-wrap {\n    display: inline-block;\n  }\n\n  /* fix cursor alignment */\n  .ProseMirror .emoji-common-node {\n    display: inline;\n    vertical-align: baseline;\n\n    img {\n      display: inline-block;\n      vertical-align: middle;\n    }\n  }\n\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", ";\n  ", ";\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n  ", "\n\n  /** Global selector for extensions, as .danger tag is assigned to root level node which is unaccessible from triggered child node **/\n  /* Danger when nested node */\n  .danger .extension-container {\n    background: rgb(255, 189, 173, 0.5); /* R75 with 50% opactiy */\n    transition: opacity 0s;\n  }\n\n  /* Danger when top level node */\n  .danger > span > .extension-container {\n    background: ", ";\n    box-shadow: 0 0 0 ", "px ", ";\n  }\n\n  .panelView-content-wrap {\n    box-sizing: border-box;\n  }\n\n  .mediaGroupView-content-wrap ul {\n    padding: 0;\n  }\n\n  /** Needed to override any cleared floats, e.g. image wrapping */\n  div.fabric-editor-block-mark[class^='fabric-editor-align'] {\n    clear: none !important;\n  }\n\n  .fabric-editor-align-end {\n    text-align: right;\n  }\n\n  .fabric-editor-align-start {\n    text-align: left;\n  }\n\n  .fabric-editor-align-center {\n    text-align: center;\n  }\n\n  .hyperlink-floating-toolbar {\n    padding: 0;\n  }\n\n  /* Link icon in the Atlaskit package \n     is bigger than the others\n  */\n  .hyperlink-open-link {\n    svg {\n      max-width: 18px;\n    }\n    &[href] {\n      padding: 0 4px;\n    }\n  }\n\n"])), editorFontSize, whitespaceSharedStyles, paragraphSharedStyles, listsSharedStyles, indentationSharedStyles, shadowSharedStyle, inlineNodeSharedStyle, blocktypeStyles, textFormattingStyles, placeholderTextStyles, placeholderStyles, codeBlockStyles, listsStyles, ruleStyles, mediaStyles, layoutStyles, telepointerStyle, gapCursorStyles, tableStyles, panelStyles, fakeCursorStyles, mentionsStyles, tasksAndDecisionsStyles, gridStyles, linkStyles, blockMarksSharedStyles, dateSharedStyle, extensionStyles, akEditorDeleteBackground, akEditorSelectedBorderBoldSize, akEditorDeleteBorder);
export default ContentStyles;
var templateObject_1;
//# sourceMappingURL=index.js.map