"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var styled_components_1 = require("styled-components");
var theme_1 = require("@atlaskit/theme");
var editor_common_1 = require("@atlaskit/editor-common");
var styles_1 = require("../../styles");
var editor_common_2 = require("@atlaskit/editor-common");
exports.codeBlockStyles = styled_components_1.css(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  .ProseMirror .code-block {\n    background: ", ";\n    font-family: ", ";\n    border: ", "px solid transparent;\n    border-radius: ", "px;\n    font-size: 14px;\n    line-height: 24px;\n    margin: ", " 0 0 0;\n    counter-reset: line;\n    display: flex;\n    min-width: ", "px;\n\n    .line-number-gutter {\n      background-color: ", ";\n      color: ", ";\n      text-align: right;\n      user-select: none;\n      padding: ", " 8px;\n      border-radius: ", "px;\n      font-size: 12px;\n      line-height: 24px;\n\n      span {\n        display: block;\n\n        &::before {\n          counter-increment: line;\n          content: counter(line);\n          display: inline-block;\n        }\n      }\n    }\n\n    .code-content {\n      color: ", ";\n      border-radius: ", "px;\n      padding: ", " 16px;\n      overflow: auto;\n      display: flex;\n      flex: 1;\n\n      pre {\n        width: 100%;\n      }\n      code {\n        display: inline-block;\n        min-width: 100%;\n        tab-size: 4;\n      }\n    }\n\n    /* We render this as a basic box in IE11 because it can't handle scrolling */\n    &.ie11 {\n      display: block;\n      .line-number-gutter {\n        display: none;\n      }\n      .code-content {\n        display: block;\n        overflow: visible;\n\n        pre {\n          width: auto;\n        }\n        code {\n          display: inline;\n        }\n      }\n    }\n  }\n\n  .ProseMirror li > .code-block {\n    margin: 0;\n  }\n\n  /* Danger when top level node */\n  .ProseMirror .danger.code-block {\n    border: ", "px solid ", ";\n    .line-number-gutter {\n      background-color: ", ";\n      color: ", ";\n    }\n\n    .code-content {\n      background-color: ", ";\n    }\n  }\n\n  /* Danger when nested node */\n  .ProseMirror .danger .code-block {\n    .line-number-gutter {\n      background-color: rgba(255, 143, 115, 0.5);\n      color: ", ";\n    }\n\n    .code-content {\n      background-color: ", ";\n      background-color: rgba(255, 189, 173, 0.5);\n    }\n  }\n"], ["\n  .ProseMirror .code-block {\n    background: ", ";\n    font-family: ", ";\n    border: ", "px solid transparent;\n    border-radius: ", "px;\n    font-size: 14px;\n    line-height: 24px;\n    margin: ", " 0 0 0;\n    counter-reset: line;\n    display: flex;\n    min-width: ", "px;\n\n    .line-number-gutter {\n      background-color: ",
    ";\n      color: ", ";\n      text-align: right;\n      user-select: none;\n      padding: ", " 8px;\n      border-radius: ", "px;\n      font-size: 12px;\n      line-height: 24px;\n\n      span {\n        display: block;\n\n        &::before {\n          counter-increment: line;\n          content: counter(line);\n          display: inline-block;\n        }\n      }\n    }\n\n    .code-content {\n      color: ", ";\n      border-radius: ", "px;\n      padding: ", " 16px;\n      overflow: auto;\n      display: flex;\n      flex: 1;\n\n      pre {\n        width: 100%;\n      }\n      code {\n        display: inline-block;\n        min-width: 100%;\n        tab-size: 4;\n      }\n    }\n\n    /* We render this as a basic box in IE11 because it can't handle scrolling */\n    &.ie11 {\n      display: block;\n      .line-number-gutter {\n        display: none;\n      }\n      .code-content {\n        display: block;\n        overflow: visible;\n\n        pre {\n          width: auto;\n        }\n        code {\n          display: inline;\n        }\n      }\n    }\n  }\n\n  .ProseMirror li > .code-block {\n    margin: 0;\n  }\n\n  /* Danger when top level node */\n  .ProseMirror .danger.code-block {\n    border: ", "px solid ", ";\n    .line-number-gutter {\n      background-color: ", ";\n      color: ", ";\n    }\n\n    .code-content {\n      background-color: ", ";\n    }\n  }\n\n  /* Danger when nested node */\n  .ProseMirror .danger .code-block {\n    .line-number-gutter {\n      background-color: rgba(255, 143, 115, 0.5);\n      color: ", ";\n    }\n\n    .code-content {\n      background-color: ", ";\n      background-color: rgba(255, 189, 173, 0.5);\n    }\n  }\n"])), theme_1.themed({ light: theme_1.colors.N20, dark: theme_1.colors.DN50 }), styles_1.akEditorCodeFontFamily, editor_common_2.akEditorSelectedBorderSize, theme_1.borderRadius(), editor_common_1.blockNodesVerticalMargin, editor_common_1.akEditorTableCellMinWidth, theme_1.themed({
    light: 'rgba(9, 30, 66, 0.04)',
    dark: theme_1.colors.DN40,
}), theme_1.colors.N300, styles_1.akEditorCodeBlockPadding, theme_1.borderRadius(), theme_1.themed({ light: theme_1.colors.N800, dark: theme_1.colors.DN500 }), theme_1.borderRadius(), styles_1.akEditorCodeBlockPadding, editor_common_2.akEditorSelectedBorderSize, editor_common_2.akEditorDeleteBorder, theme_1.colors.R75, editor_common_2.akEditorDeleteIconColor, editor_common_2.akEditorDeleteBackground, editor_common_2.akEditorDeleteIconColor, editor_common_2.akEditorDeleteBackground);
var templateObject_1;
//# sourceMappingURL=styles.js.map