"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
// @ts-ignore: unused variable
var styled_components_1 = require("styled-components");
var theme_1 = require("@atlaskit/theme");
var editor_common_1 = require("@atlaskit/editor-common");
var styles_1 = require("../../../ui/styles");
var types_1 = require("../types");
var N40A = theme_1.colors.N40A, B100 = theme_1.colors.B100, B300 = theme_1.colors.B300, N300 = theme_1.colors.N300, B75 = theme_1.colors.B75, N20 = theme_1.colors.N20, N50 = theme_1.colors.N50, R50 = theme_1.colors.R50, R300 = theme_1.colors.R300, R75 = theme_1.colors.R75, N20A = theme_1.colors.N20A, N60A = theme_1.colors.N60A, N30 = theme_1.colors.N30, N90 = theme_1.colors.N90, N200 = theme_1.colors.N200, N0 = theme_1.colors.N0, R500 = theme_1.colors.R500, Y50 = theme_1.colors.Y50, Y200 = theme_1.colors.Y200;
exports.tableToolbarColor = N20;
exports.tableBorderColor = N50;
exports.tableFloatingControlsColor = N20;
exports.tableCellSelectedColor = B75;
exports.tableToolbarSelectedColor = B100;
exports.tableBorderSelectedColor = B300;
exports.tableCellDeleteColor = R50;
exports.tableBorderDeleteColor = R300;
exports.tableToolbarDeleteColor = R75;
exports.tableToolbarSize = editor_common_1.akEditorTableToolbarSize;
exports.tableBorderRadiusSize = 3;
exports.tableInsertColumnButtonSize = 20;
exports.tableDeleteButtonSize = 16;
exports.tableDeleteButtonOffset = 6;
exports.tablePadding = 8;
exports.contextualMenuTriggerSize = 16;
exports.contextualMenuDropdownWidth = 180;
exports.layoutButtonSize = 32;
exports.tableInsertColumnButtonOffset = 3;
exports.tableScrollbarOffset = 15;
exports.tableMarginFullWidthMode = 2;
exports.lineMarkerOffsetFromColumnControls = 13;
exports.lineMarkerSize = 4;
exports.columnControlsDecorationHeight = 25;
exports.columnControlsZIndex = editor_common_1.akEditorUnitZIndex * 10;
exports.columnControlsSelectedZIndex = exports.columnControlsZIndex + 1;
exports.columnResizeHandleZIndex = exports.columnControlsSelectedZIndex + 1;
var isIE11 = editor_common_1.browser.ie_version === 11;
var InsertLine = function (css) { return "\n  ." + types_1.TableCssClassName.CONTROLS_INSERT_LINE + " {\n    background: " + exports.tableBorderSelectedColor + ";\n    display: none;\n    position: absolute;\n    z-index: " + editor_common_1.akEditorUnitZIndex + ";\n    " + css + "\n  }\n"; };
var Marker = "\n  background-color: " + exports.tableBorderColor + ";\n  position: absolute;\n  height: " + exports.lineMarkerSize + "px;\n  width: " + exports.lineMarkerSize + "px;\n  border-radius: 50%;\n  pointer-events: none;\n";
var InsertMarker = function (css) { return "\n  ." + types_1.TableCssClassName.CONTROLS_INSERT_MARKER + " {\n    " + Marker + ";\n    " + css + "\n  }\n"; };
var Button = function (css) { return "\n  border-radius: " + theme_1.borderRadius() + "px;\n  border-width: 0px;\n  display: inline-flex;\n  max-width: 100%;\n  text-align: center;\n  margin: 0px;\n  padding: 0px;\n  text-decoration: none;\n  transition: background 0.1s ease-out 0s, box-shadow 0.15s cubic-bezier(0.47, 0.03, 0.49, 1.38) 0s;\n  outline: none !important;\n  cursor: none;\n\n  > ." + types_1.TableCssClassName.CONTROLS_BUTTON_ICON + " {\n    display: inline-flex;\n    max-height: 100%;\n    max-width: 100%;\n  }\n  " + css + "\n"; };
var HeaderButton = function (css) { return "\n  ." + types_1.TableCssClassName.CONTROLS_BUTTON + " {\n    background: " + exports.tableToolbarColor + ";\n    border-top: 1px solid " + exports.tableBorderColor + ";\n    border-left: 1px solid " + exports.tableBorderColor + ";\n    display: block;\n    box-sizing: border-box;\n    padding: 0;\n\n    :focus {\n      outline: none;\n    }\n    " + css + "\n  }\n\n  ." + types_1.TableCssClassName.ROW_CONTROLS_BUTTON + "::after {\n    content: ' ';\n    background-color: transparent;\n    left: -15px;\n    top: 0;\n    position: absolute;\n    width: 15px;\n    height: 100%;\n    z-index: 1;\n  }\n\n  .active ." + types_1.TableCssClassName.CONTROLS_BUTTON + " {\n    color: " + N0 + ";\n    background-color: " + exports.tableToolbarSelectedColor + ";\n    border-color: " + exports.tableBorderSelectedColor + ";\n  }\n"; };
var HeaderButtonHover = function () { return "\n  ." + types_1.TableCssClassName.CONTROLS_BUTTON + ":hover {\n    color: " + N0 + ";\n    background-color: " + exports.tableToolbarSelectedColor + ";\n    border-color: " + exports.tableBorderSelectedColor + ";\n    cursor: pointer;\n  }\n"; };
var HeaderButtonDanger = function () { return "\n  ." + types_1.TableCssClassName.HOVERED_CELL_IN_DANGER + " ." + types_1.TableCssClassName.CONTROLS_BUTTON + " {\n    background-color: " + exports.tableToolbarDeleteColor + ";\n    border-color: " + exports.tableBorderDeleteColor + ";\n    position: relative;\n    z-index: " + editor_common_1.akEditorUnitZIndex + ";\n  }\n"; };
var InsertButton = function () { return "\n  ." + types_1.TableCssClassName.CONTROLS_INSERT_BUTTON_INNER + " {\n    position: absolute;\n    z-index: " + (editor_common_1.akEditorUnitZIndex + 10) + ";\n    bottom: 0;\n  }\n  ." + types_1.TableCssClassName.CONTROLS_INSERT_BUTTON_INNER + ",\n  ." + types_1.TableCssClassName.CONTROLS_INSERT_BUTTON + " {\n    height: " + exports.tableInsertColumnButtonSize + "px;\n    width: " + exports.tableInsertColumnButtonSize + "px;\n  }\n  ." + types_1.TableCssClassName.CONTROLS_INSERT_BUTTON + " {\n    " + Button("\n      background: white;\n      box-shadow: 0 4px 8px -2px " + N60A + ", 0 0 1px " + N60A + ";\n      color: " + N300 + ";\n    ") + "\n  }\n  ." + types_1.TableCssClassName.CONTROLS_INSERT_LINE + " {\n    display: none;\n  }\n  &:hover ." + types_1.TableCssClassName.CONTROLS_INSERT_LINE + " {\n    display: flex;\n  }\n"; };
var InsertButtonHover = function () { return "\n  ." + types_1.TableCssClassName.CONTROLS_INSERT_BUTTON + ":hover {\n    background: " + B300 + ";\n    color: white;\n    cursor: pointer;\n  }\n"; };
var insertColumnButtonWrapper = "\n  " + InsertButton() + "\n  " + InsertButtonHover() + "\n  " + InsertLine("\n    width: 2px;\n    left: 9px;\n  ") + "\n";
var insertRowButtonWrapper = "\n  " + InsertButton() + "\n  " + InsertButtonHover() + "\n  " + InsertLine("\n    height: 2px;\n    top: -11px;\n    left: " + (exports.tableInsertColumnButtonSize - 1) + "px;\n  ") + "\n";
var columnControlsLineMarker = "\n  ." + types_1.TableCssClassName.TABLE_CONTAINER + "." + types_1.TableCssClassName.WITH_CONTROLS + " table tr:first-child td,\n  ." + types_1.TableCssClassName.TABLE_CONTAINER + "." + types_1.TableCssClassName.WITH_CONTROLS + " table tr:first-child th {\n    position: relative;\n\n    &::before {\n      content: ' ';\n      " + Marker + ";\n      top: -" + (exports.tableToolbarSize + exports.lineMarkerOffsetFromColumnControls) + "px;\n      right: -" + exports.lineMarkerSize / 2 + "px;\n    }\n  }\n";
var DeleteButton = "\n  ." + types_1.TableCssClassName.CONTROLS_DELETE_BUTTON_WRAP + ",\n  ." + types_1.TableCssClassName.CONTROLS_DELETE_BUTTON + " {\n    height: " + exports.tableDeleteButtonSize + "px;\n    width: " + exports.tableDeleteButtonSize + "px;\n  }\n  ." + types_1.TableCssClassName.CONTROLS_DELETE_BUTTON_WRAP + " {\n    ." + types_1.TableCssClassName.CONTROLS_DELETE_BUTTON + " {\n      " + Button("\n        background: " + N20A + ";\n        color: " + N300 + ";\n      ") + "\n    }\n  }\n\n  ." + types_1.TableCssClassName.CONTROLS_DELETE_BUTTON + ":hover {\n    background: " + R300 + ";\n    color: white;\n    cursor: pointer;\n  }\n";
var OverflowShadow = "\n." + types_1.TableCssClassName.TABLE_RIGHT_SHADOW + ",\n." + types_1.TableCssClassName.TABLE_LEFT_SHADOW + "{\n  display: block;\n  height: calc(100% - " + (editor_common_1.tableMarginTop + editor_common_1.tableMarginBottom + exports.tableToolbarSize - 2) + "px);\n  position: absolute;\n  pointer-events: none;\n  top: " + (editor_common_1.tableMarginTop + exports.tableToolbarSize - 1) + "px;\n  z-index: " + editor_common_1.akEditorSmallZIndex + ";\n  width: 8px;\n}\n." + types_1.TableCssClassName.TABLE_LEFT_SHADOW + " {\n  background: linear-gradient(\n    to left,\n    rgba(99, 114, 130, 0) 0,\n    " + N40A + " 100%\n  );\n  left: 0px;\n}\n." + types_1.TableCssClassName.TABLE_RIGHT_SHADOW + " {\n  background: linear-gradient(\n    to right,\n    rgba(99, 114, 130, 0) 0,\n    " + N40A + " 100%\n  );\n  left: calc(100% + 2px);\n}\n." + types_1.TableCssClassName.WITH_CONTROLS + " {\n  ." + types_1.TableCssClassName.TABLE_RIGHT_SHADOW + ",\n  ." + types_1.TableCssClassName.TABLE_LEFT_SHADOW + "{\n    height: calc(100% - " + (editor_common_1.tableMarginTop + editor_common_1.tableMarginBottom - 2) + "px);\n    top: " + (editor_common_1.tableMarginTop - 1) + "px;\n  }\n  ." + types_1.TableCssClassName.TABLE_LEFT_SHADOW + " {\n    border-left: 1px solid " + exports.tableBorderColor + ";\n  }\n}\n";
var columnHeaderButton = function (css) { return "\n  background: " + exports.tableToolbarColor + ";\n  border-top: 1px solid " + exports.tableBorderColor + ";\n  border-left: 1px solid " + exports.tableBorderColor + ";\n  display: block;\n  box-sizing: border-box;\n  padding: 0;\n\n  :focus {\n    outline: none;\n  }\n\n  " + css + "\n"; };
var columnHeaderButtonSelected = "\n  color: " + N0 + ";\n  background-color: " + exports.tableToolbarSelectedColor + ";\n  border-color: " + exports.tableBorderSelectedColor + ";\n  z-index: " + exports.columnControlsSelectedZIndex + ";\n";
var columnControlsDecoration = "\n  ." + types_1.TableCssClassName.COLUMN_CONTROLS_DECORATIONS + " {\n    display: none;\n    cursor: pointer;\n    position: absolute;\n    width: calc(100% + " + editor_common_1.tableCellBorderWidth * 2 + "px);\n    left: -1px;\n    top: -" + (exports.columnControlsDecorationHeight + editor_common_1.tableCellBorderWidth) + "px;\n    height: " + exports.columnControlsDecorationHeight + "px;\n\n    &::after {\n      content: ' ';\n\n      " + columnHeaderButton("\n        border-right: " + editor_common_1.tableCellBorderWidth + "px solid " + exports.tableBorderColor + ";\n        border-bottom: none;\n        height: " + exports.tableToolbarSize + "px;\n        width: 100%;\n        position: absolute;\n        top: " + (exports.columnControlsDecorationHeight - exports.tableToolbarSize) + "px;\n        left: 0px;\n        z-index: " + exports.columnControlsZIndex + ";\n      ") + "\n    }\n  }\n\n  ." + types_1.TableCssClassName.WITH_CONTROLS + " ." + types_1.TableCssClassName.COLUMN_CONTROLS_DECORATIONS + " {\n    display: block;\n  }\n\n  table tr:first-child td." + types_1.TableCssClassName.TABLE_CELL + ",\n  table tr:first-child th." + types_1.TableCssClassName.TABLE_HEADER_CELL + " {\n    &." + types_1.TableCssClassName.COLUMN_SELECTED + ",\n    &." + types_1.TableCssClassName.HOVERED_COLUMN + ",\n    &." + types_1.TableCssClassName.HOVERED_TABLE + " {\n      ." + types_1.TableCssClassName.COLUMN_CONTROLS_DECORATIONS + "::after {\n        " + columnHeaderButtonSelected + ";\n      }\n\n      &." + types_1.TableCssClassName.HOVERED_CELL_IN_DANGER + " ." + types_1.TableCssClassName.COLUMN_CONTROLS_DECORATIONS + "::after {\n        background-color: " + exports.tableToolbarDeleteColor + ";\n        border: 1px solid " + exports.tableBorderDeleteColor + ";\n        border-bottom: none;\n        z-index: " + editor_common_1.akEditorUnitZIndex * 100 + ";\n      }\n    }\n  }\n\n  ." + types_1.TableCssClassName.TABLE_SELECTED + " table tr:first-child td." + types_1.TableCssClassName.TABLE_CELL + ",\n  ." + types_1.TableCssClassName.TABLE_SELECTED + " table tr:first-child th." + types_1.TableCssClassName.TABLE_HEADER_CELL + " {\n    ." + types_1.TableCssClassName.COLUMN_CONTROLS_DECORATIONS + "::after {\n      " + columnHeaderButtonSelected + ";\n    }\n  }\n\n  table ." + types_1.TableCssClassName.RESIZE_HANDLE + " {\n    position: absolute;\n    top: " + (exports.columnControlsDecorationHeight - exports.tableToolbarSize) + "px;\n    width: " + editor_common_1.tableResizeHandleWidth * 2 + "px;\n    cursor: col-resize;\n    z-index: " + 1000 + ";\n\n    :after {\n      background: " + exports.tableBorderSelectedColor + ";\n      display: none;\n      content: '';\n      height: 100%;\n      width: 2px;\n      position: absolute;\n      left: 50%;\n    }\n\n    :hover {\n      :after {\n        display: block;\n      }\n    }\n  }\n";
var hoveredDeleteButton = "\n  ." + types_1.TableCssClassName.TABLE_CONTAINER + "." + types_1.TableCssClassName.HOVERED_DELETE_BUTTON + " {\n    ." + types_1.TableCssClassName.SELECTED_CELL + ",\n    ." + types_1.TableCssClassName.COLUMN_SELECTED + ",\n    ." + types_1.TableCssClassName.HOVERED_CELL + " {\n      border: 1px solid " + exports.tableBorderDeleteColor + ";\n    }\n    ." + types_1.TableCssClassName.SELECTED_CELL + "::after {\n      background: " + exports.tableCellDeleteColor + ";\n    }\n  }\n";
var hoveredCell = "\n  :not(." + types_1.TableCssClassName.IS_RESIZING + ") ." + types_1.TableCssClassName.TABLE_CONTAINER + ":not(." + types_1.TableCssClassName.HOVERED_DELETE_BUTTON + ") {\n    ." + types_1.TableCssClassName.HOVERED_CELL + " {\n      position: relative;\n      border: 1px solid " + exports.tableBorderSelectedColor + ";\n    }\n  }\n";
var hoveredWarningCell = "\n  :not(." + types_1.TableCssClassName.IS_RESIZING + ") ." + types_1.TableCssClassName.TABLE_CONTAINER + ":not(." + types_1.TableCssClassName.HOVERED_DELETE_BUTTON + ") {\n    td." + types_1.TableCssClassName.HOVERED_CELL_WARNING + " {\n      background-color: " + Y50 + " !important; // We need to override the background-color added to the cell\n      border: 1px solid " + Y200 + ";\n    }\n  }\n";
exports.tableStyles = styled_components_1.css(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n  .", " button {\n    background: ", ";\n    color: ", ";\n    cursor: none;\n  }\n\n  .", ":not(.", ") button:hover {\n    background: ", ";\n    color: white !important;\n    cursor: pointer;\n  }\n\n\n  .ProseMirror {\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n\n    .", " {\n      ", "\n    }\n\n    .", " {\n      ", "\n    }\n\n    /* Delete button*/\n    ", "\n    /* Ends Delete button*/\n\n    ", "\n    .less-padding {\n      padding: 0 ", "px;\n\n      .", " {\n        padding: 0 ", "px;\n      }\n\n      &.", "[data-number-column='true'] {\n        padding-left: ", "px;\n      }\n    }\n\n    /* Breakout only works on top level */\n    > .", " .", "[data-layout='full-width'],\n    > .", " .", "[data-layout='wide'] {\n      margin-left: 50%;\n      transform: translateX(-50%);\n    }\n    > * .", " .", " {\n      width: 100% !important;\n    }\n\n    ", ";\n\n    /* Corner controls */\n    .", " {\n      width: ", "px;\n      height: ", "px;\n      display: none;\n\n      .", " {\n        position: relative;\n\n        ", ";\n      }\n\n      .", " {\n        position: relative;\n\n        ", ";\n      }\n    }\n    .", " {\n      position: absolute;\n      top: 0;\n      width: ", "px;\n      height: ", "px;\n      border: 1px solid ", ";\n      border-radius: 0;\n      border-top-left-radius: ", "px;\n      background: ", ";\n      box-sizing: border-box;\n      padding: 0;\n      :focus {\n        outline: none;\n      }\n    }\n    .active .", " {\n      border-color: ", ";\n      background: ", ";\n    }\n    .", "[data-number-column='true'] {\n      .", ",\n      .", " {\n        width: ", "px;\n      }\n      .", " .", " {\n        border-right-width: 0;\n      }\n    }\n    :not(.", ") .", ":hover {\n      border-color: ", ";\n      background: ", ";\n      cursor: pointer;\n    }\n    :not(.", ") .", ".", " {\n      border-color: ", ";\n      background: ", ";\n    }\n\n    /* Row controls */\n    .", " {\n      width: ", "px;\n      box-sizing: border-box;\n      display: none;\n      position: relative;\n\n      ", ";\n\n      .", " {\n        display: flex;\n        flex-direction: column;\n      }\n      .", ":last-child > button {\n        border-bottom-left-radius: ", "px;\n      }\n      .", " {\n        position: relative;\n        margin-top: -1px;\n      }\n      .", ":hover,\n      .", ".active,\n      .", ":hover {\n        z-index: ", ";\n      }\n\n      ", "\n    }\n    :not(.", ") .", " {\n      ", "\n      ", "\n    }\n\n    /* Numbered column */\n    .", " {\n      position: relative;\n      float: right;\n      margin-left: ", "px;\n      top: ", "px;\n      width: ", "px;\n      box-sizing: border-box;\n      border-left: 1px solid ", ";\n    }\n    .", " {\n      border-top: 1px solid ", ";\n      border-right: 1px solid ", ";\n      box-sizing: border-box;\n      margin-top: -1px;\n      padding: 10px 2px;\n      text-align: center;\n      font-size: ", "px;\n      background-color: ", ";\n      color: ", ";\n      border-color: ", ";\n\n      :first-child {\n        margin-top: 0;\n      }\n      :last-child {\n        border-bottom: 1px solid ", ";\n      }\n    }\n    .", " {\n      .", ",\n      .", " {\n        display: block;\n      }\n      .", " {\n        border-left: 0 none;\n        padding-left: 1px;\n        margin-left: 0;\n\n        .", ".active {\n          border-bottom: 1px solid ", ";\n          border-color: ", ";\n          background-color: ", ";\n          position: relative;\n          z-index: ", ";\n          color: ", ";\n        }\n      }\n    }\n    :not(.", ") .", " {\n      .", " {\n        cursor: pointer;\n      }\n      .", ":hover {\n        border-bottom: 1px solid ", ";\n        border-color: ", ";\n        background-color: ", ";\n        position: relative;\n        z-index: ", ";\n        color: ", ";\n      }\n      .", ".", " {\n        background-color: ", ";\n        border: 1px solid ", ";\n        border-left: 0;\n        color: ", ";\n        position: relative;\n        z-index: ", ";\n      }\n    }\n\n    /* Table */\n    .", " > table {\n      overflow: hidden visible;\n      table-layout: fixed;\n\n      .", " + * {\n        margin-top: 0;\n      }\n\n      .", ",\n      .", " {\n        position: relative;\n      }\n      /* Give selected cells a blue overlay */\n      .", "::after,\n      .", "::after {\n        z-index: ", ";\n        position: absolute;\n        content: '';\n        left: 0;\n        right: 0;\n        top: 0;\n        bottom: 0;\n        opacity: 0.3;\n        pointer-events: none;\n      }\n      .", " {\n        border: 1px solid ", ";\n      }\n      .", "::after {\n        background: ", ";\n      }\n      .", " {\n        border: 1px solid ", ";\n      }\n      .", "::after {\n        background: ", ";\n      }\n    }\n    .", " {\n      position: absolute;\n      top: ", "px;\n    }\n    .", ".", " {\n      z-index: ", ";\n    }\n    .", " {\n      left: -", "px;\n    }\n    .", " {\n      padding-right: ", "px;\n      margin-right: -", "px;\n      padding-top: ", "px;\n      margin-top: -", "px;\n      padding-bottom: ", "px;\n      margin-bottom: -", "px;\n      z-index: ", ";\n      /* fixes gap cursor height */\n      overflow: ", ";\n      position: relative;\n    }\n  }\n\n  .ProseMirror.", " {\n    .", " {\n      overflow-x: ", ";\n      ", ";\n    }\n  }\n\n  .ProseMirror.", " {\n    cursor: col-resize;\n  }\n\n"], ["\n  .", " button {\n    background: ", ";\n    color: ", ";\n    cursor: none;\n  }\n\n  .", ":not(.", ") button:hover {\n    background: ", ";\n    color: white !important;\n    cursor: pointer;\n  }\n\n\n  .ProseMirror {\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n    ", ";\n\n    .", " {\n      ", "\n    }\n\n    .", " {\n      ", "\n    }\n\n    /* Delete button*/\n    ", "\n    /* Ends Delete button*/\n\n    ", "\n    .less-padding {\n      padding: 0 ", "px;\n\n      .", " {\n        padding: 0 ", "px;\n      }\n\n      &.", "[data-number-column='true'] {\n        padding-left: ", "px;\n      }\n    }\n\n    /* Breakout only works on top level */\n    > .", " .", "[data-layout='full-width'],\n    > .", " .", "[data-layout='wide'] {\n      margin-left: 50%;\n      transform: translateX(-50%);\n    }\n    > * .", " .", " {\n      width: 100% !important;\n    }\n\n    ", ";\n\n    /* Corner controls */\n    .", " {\n      width: ", "px;\n      height: ", "px;\n      display: none;\n\n      .", " {\n        position: relative;\n\n        ",
    ";\n      }\n\n      .", " {\n        position: relative;\n\n        ",
    ";\n      }\n    }\n    .", " {\n      position: absolute;\n      top: 0;\n      width: ", "px;\n      height: ", "px;\n      border: 1px solid ", ";\n      border-radius: 0;\n      border-top-left-radius: ", "px;\n      background: ", ";\n      box-sizing: border-box;\n      padding: 0;\n      :focus {\n        outline: none;\n      }\n    }\n    .active .", " {\n      border-color: ", ";\n      background: ", ";\n    }\n    .", "[data-number-column='true'] {\n      .", ",\n      .", " {\n        width: ", "px;\n      }\n      .", " .", " {\n        border-right-width: 0;\n      }\n    }\n    :not(.", ") .", ":hover {\n      border-color: ", ";\n      background: ", ";\n      cursor: pointer;\n    }\n    :not(.", ") .", ".", " {\n      border-color: ", ";\n      background: ", ";\n    }\n\n    /* Row controls */\n    .", " {\n      width: ", "px;\n      box-sizing: border-box;\n      display: none;\n      position: relative;\n\n      ",
    ";\n\n      .", " {\n        display: flex;\n        flex-direction: column;\n      }\n      .", ":last-child > button {\n        border-bottom-left-radius: ", "px;\n      }\n      .", " {\n        position: relative;\n        margin-top: -1px;\n      }\n      .", ":hover,\n      .", ".active,\n      .", ":hover {\n        z-index: ", ";\n      }\n\n      ",
    "\n    }\n    :not(.", ") .", " {\n      ", "\n      ", "\n    }\n\n    /* Numbered column */\n    .", " {\n      position: relative;\n      float: right;\n      margin-left: ", "px;\n      top: ", "px;\n      width: ", "px;\n      box-sizing: border-box;\n      border-left: 1px solid ", ";\n    }\n    .", " {\n      border-top: 1px solid ", ";\n      border-right: 1px solid ", ";\n      box-sizing: border-box;\n      margin-top: -1px;\n      padding: 10px 2px;\n      text-align: center;\n      font-size: ", "px;\n      background-color: ", ";\n      color: ", ";\n      border-color: ", ";\n\n      :first-child {\n        margin-top: 0;\n      }\n      :last-child {\n        border-bottom: 1px solid ", ";\n      }\n    }\n    .", " {\n      .", ",\n      .", " {\n        display: block;\n      }\n      .", " {\n        border-left: 0 none;\n        padding-left: 1px;\n        margin-left: 0;\n\n        .", ".active {\n          border-bottom: 1px solid ", ";\n          border-color: ", ";\n          background-color: ", ";\n          position: relative;\n          z-index: ", ";\n          color: ", ";\n        }\n      }\n    }\n    :not(.", ") .", " {\n      .", " {\n        cursor: pointer;\n      }\n      .", ":hover {\n        border-bottom: 1px solid ", ";\n        border-color: ", ";\n        background-color: ", ";\n        position: relative;\n        z-index: ", ";\n        color: ", ";\n      }\n      .", ".", " {\n        background-color: ", ";\n        border: 1px solid ", ";\n        border-left: 0;\n        color: ", ";\n        position: relative;\n        z-index: ", ";\n      }\n    }\n\n    /* Table */\n    .", " > table {\n      overflow: hidden visible;\n      table-layout: fixed;\n\n      .", " + * {\n        margin-top: 0;\n      }\n\n      .", ",\n      .", " {\n        position: relative;\n      }\n      /* Give selected cells a blue overlay */\n      .", "::after,\n      .", "::after {\n        z-index: ", ";\n        position: absolute;\n        content: '';\n        left: 0;\n        right: 0;\n        top: 0;\n        bottom: 0;\n        opacity: 0.3;\n        pointer-events: none;\n      }\n      .", " {\n        border: 1px solid ", ";\n      }\n      .", "::after {\n        background: ", ";\n      }\n      .", " {\n        border: 1px solid ", ";\n      }\n      .", "::after {\n        background: ", ";\n      }\n    }\n    .", " {\n      position: absolute;\n      top: ", "px;\n    }\n    .", ".", " {\n      z-index: ", ";\n    }\n    .", " {\n      left: -", "px;\n    }\n    .", " {\n      padding-right: ", "px;\n      margin-right: -", "px;\n      padding-top: ", "px;\n      margin-top: -", "px;\n      padding-bottom: ", "px;\n      margin-bottom: -", "px;\n      z-index: ", ";\n      /* fixes gap cursor height */\n      overflow: ", ";\n      position: relative;\n    }\n  }\n\n  .ProseMirror.", " {\n    .", " {\n      overflow-x: ", ";\n      ", ";\n    }\n  }\n\n  .ProseMirror.", " {\n    cursor: col-resize;\n  }\n\n"])), types_1.TableCssClassName.LAYOUT_BUTTON, N20A, N300, types_1.TableCssClassName.LAYOUT_BUTTON, types_1.TableCssClassName.IS_RESIZING, B300, editor_common_1.tableSharedStyle, columnControlsLineMarker, hoveredDeleteButton, hoveredCell, hoveredWarningCell, types_1.TableCssClassName.CONTROLS_FLOATING_BUTTON_COLUMN, insertColumnButtonWrapper, types_1.TableCssClassName.CONTROLS_FLOATING_BUTTON_ROW, insertRowButtonWrapper, DeleteButton, OverflowShadow, exports.tablePadding, types_1.TableCssClassName.ROW_CONTROLS_WRAPPER, exports.tablePadding, types_1.TableCssClassName.TABLE_CONTAINER, editor_common_1.akEditorTableNumberColumnWidth + exports.tablePadding - 1, types_1.TableCssClassName.NODEVIEW_WRAPPER, types_1.TableCssClassName.TABLE_CONTAINER, types_1.TableCssClassName.NODEVIEW_WRAPPER, types_1.TableCssClassName.TABLE_CONTAINER, types_1.TableCssClassName.NODEVIEW_WRAPPER, types_1.TableCssClassName.TABLE_CONTAINER, columnControlsDecoration, types_1.TableCssClassName.CORNER_CONTROLS, exports.tableToolbarSize + 1, exports.tableToolbarSize + 1, types_1.TableCssClassName.CORNER_CONTROLS_INSERT_ROW_MARKER, InsertMarker("\n          left: -11px;\n          top: 9px;\n        "), types_1.TableCssClassName.CORNER_CONTROLS_INSERT_COLUMN_MARKER, InsertMarker("\n          right: -1px;\n          top: -12px;\n        "), types_1.TableCssClassName.CONTROLS_CORNER_BUTTON, exports.tableToolbarSize + 1, exports.tableToolbarSize + 1, exports.tableBorderColor, exports.tableBorderRadiusSize, exports.tableToolbarColor, types_1.TableCssClassName.CONTROLS_CORNER_BUTTON, exports.tableBorderSelectedColor, exports.tableToolbarSelectedColor, types_1.TableCssClassName.TABLE_CONTAINER, types_1.TableCssClassName.CORNER_CONTROLS, types_1.TableCssClassName.CONTROLS_CORNER_BUTTON, editor_common_1.akEditorTableToolbarSize + editor_common_1.akEditorTableNumberColumnWidth, types_1.TableCssClassName.ROW_CONTROLS, types_1.TableCssClassName.CONTROLS_BUTTON, types_1.TableCssClassName.IS_RESIZING, types_1.TableCssClassName.CONTROLS_CORNER_BUTTON, exports.tableBorderSelectedColor, exports.tableToolbarSelectedColor, types_1.TableCssClassName.IS_RESIZING, types_1.TableCssClassName.CONTROLS_CORNER_BUTTON, types_1.TableCssClassName.HOVERED_CELL_IN_DANGER, exports.tableBorderDeleteColor, exports.tableToolbarDeleteColor, types_1.TableCssClassName.ROW_CONTROLS, exports.tableToolbarSize, InsertMarker("\n        bottom: -1px;\n        left: -11px;\n      "), types_1.TableCssClassName.ROW_CONTROLS_INNER, types_1.TableCssClassName.ROW_CONTROLS_BUTTON_WRAP, exports.tableBorderRadiusSize, types_1.TableCssClassName.ROW_CONTROLS_BUTTON_WRAP, types_1.TableCssClassName.ROW_CONTROLS_BUTTON_WRAP, types_1.TableCssClassName.ROW_CONTROLS_BUTTON_WRAP, types_1.TableCssClassName.CONTROLS_BUTTON, editor_common_1.akEditorUnitZIndex, HeaderButton("\n        border-bottom: 1px solid " + exports.tableBorderColor + ";\n        border-right: 0px;\n        border-radius: 0;\n        height: 100%;\n        width: " + exports.tableToolbarSize + "px;\n\n        ." + types_1.TableCssClassName.CONTROLS_BUTTON_OVERLAY + " {\n          position: absolute;\n          width: 30px;\n          height: 50%;\n          right: 0;\n          bottom: 0;\n        }\n        ." + types_1.TableCssClassName.CONTROLS_BUTTON_OVERLAY + ":first-child {\n          top: 0;\n        }\n      "), types_1.TableCssClassName.IS_RESIZING, types_1.TableCssClassName.ROW_CONTROLS, HeaderButtonHover(), HeaderButtonDanger(), types_1.TableCssClassName.NUMBERED_COLUMN, editor_common_1.akEditorTableToolbarSize - 1, editor_common_1.akEditorTableToolbarSize, editor_common_1.akEditorTableNumberColumnWidth + 1, editor_common_1.akEditorTableBorder, types_1.TableCssClassName.NUMBERED_COLUMN_BUTTON, editor_common_1.akEditorTableBorder, editor_common_1.akEditorTableBorder, theme_1.fontSize(), exports.tableToolbarColor, N200, editor_common_1.akEditorTableBorder, editor_common_1.akEditorTableBorder, types_1.TableCssClassName.WITH_CONTROLS, types_1.TableCssClassName.CORNER_CONTROLS, types_1.TableCssClassName.ROW_CONTROLS, types_1.TableCssClassName.NUMBERED_COLUMN, types_1.TableCssClassName.NUMBERED_COLUMN_BUTTON, exports.tableBorderSelectedColor, exports.tableBorderSelectedColor, exports.tableToolbarSelectedColor, editor_common_1.akEditorUnitZIndex, N0, types_1.TableCssClassName.IS_RESIZING, types_1.TableCssClassName.WITH_CONTROLS, types_1.TableCssClassName.NUMBERED_COLUMN_BUTTON, types_1.TableCssClassName.NUMBERED_COLUMN_BUTTON, exports.tableBorderSelectedColor, exports.tableBorderSelectedColor, exports.tableToolbarSelectedColor, editor_common_1.akEditorUnitZIndex, N0, types_1.TableCssClassName.NUMBERED_COLUMN_BUTTON, types_1.TableCssClassName.HOVERED_CELL_IN_DANGER, exports.tableToolbarDeleteColor, exports.tableBorderDeleteColor, R500, editor_common_1.akEditorUnitZIndex, types_1.TableCssClassName.TABLE_NODE_WRAPPER, types_1.TableCssClassName.COLUMN_CONTROLS_DECORATIONS, types_1.TableCssClassName.SELECTED_CELL, types_1.TableCssClassName.HOVERED_CELL_IN_DANGER, types_1.TableCssClassName.SELECTED_CELL, types_1.TableCssClassName.HOVERED_CELL_IN_DANGER, editor_common_1.akEditorSmallZIndex, types_1.TableCssClassName.SELECTED_CELL, exports.tableBorderSelectedColor, types_1.TableCssClassName.SELECTED_CELL, exports.tableCellSelectedColor, types_1.TableCssClassName.HOVERED_CELL_IN_DANGER, exports.tableBorderDeleteColor, types_1.TableCssClassName.HOVERED_CELL_IN_DANGER, exports.tableCellDeleteColor, types_1.TableCssClassName.ROW_CONTROLS_WRAPPER, editor_common_1.tableMarginTop - 1, types_1.TableCssClassName.ROW_CONTROLS_WRAPPER, types_1.TableCssClassName.TABLE_LEFT_SHADOW, editor_common_1.akEditorUnitZIndex, types_1.TableCssClassName.ROW_CONTROLS_WRAPPER, exports.tableToolbarSize, types_1.TableCssClassName.TABLE_NODE_WRAPPER, exports.tableInsertColumnButtonSize / 2, exports.tableInsertColumnButtonSize / 2, exports.tableInsertColumnButtonSize / 2, exports.tableInsertColumnButtonSize / 2, exports.tableScrollbarOffset, exports.tableScrollbarOffset, editor_common_1.akEditorUnitZIndex - 1, isIE11 ? 'none' : 'auto', types_1.TableCssClassName.IS_RESIZING, types_1.TableCssClassName.TABLE_NODE_WRAPPER, isIE11 ? 'none' : 'auto', !isIE11 ? styles_1.scrollbarStyles : '', types_1.TableCssClassName.RESIZE_CURSOR);
exports.tableFloatingCellButtonStyles = styled_components_1.css(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n  > div {\n    background: ", ";\n    border-radius: ", "px;\n    border: 2px solid ", ";\n    display: flex;\n    height: ", "px;\n    flex-direction: column;\n  }\n  button {\n    flex-direction: column;\n    padding: 0;\n    height: 100%;\n    display: flex;\n  }\n  span {\n    pointer-events: none;\n  }\n"], ["\n  > div {\n    background: ", ";\n    border-radius: ", "px;\n    border: 2px solid ", ";\n    display: flex;\n    height: ", "px;\n    flex-direction: column;\n  }\n  button {\n    flex-direction: column;\n    padding: 0;\n    height: 100%;\n    display: flex;\n  }\n  span {\n    pointer-events: none;\n  }\n"])), N20, theme_1.borderRadius(), N0, exports.contextualMenuTriggerSize - 2);
exports.tableFullPageEditorStyles = styled_components_1.css(templateObject_3 || (templateObject_3 = tslib_1.__makeTemplateObject(["\n  .ProseMirror .", " > table {\n    margin-left: 0;\n    margin-right: 0;\n    width: 100%;\n  }\n"], ["\n  .ProseMirror .", " > table {\n    margin-left: 0;\n    margin-right: 0;\n    width: 100%;\n  }\n"])), types_1.TableCssClassName.TABLE_NODE_WRAPPER);
exports.tableCommentEditorStyles = styled_components_1.css(templateObject_4 || (templateObject_4 = tslib_1.__makeTemplateObject(["\n  .ProseMirror .", " > table {\n    margin-left: 0;\n    margin-right: 0;\n\n    ", ";\n  }\n"], ["\n  .ProseMirror .", " > table {\n    margin-left: 0;\n    margin-right: 0;\n\n    ", ";\n  }\n"])), types_1.TableCssClassName.TABLE_NODE_WRAPPER, styles_1.scrollbarStyles);
exports.tablePopupStyles = styled_components_1.css(templateObject_5 || (templateObject_5 = tslib_1.__makeTemplateObject(["\n  .", " {\n    border-radius: ", "px;\n    background: white;\n    box-shadow: 0 4px 8px -2px ", ", 0 0 1px ", ";\n    display: block;\n    position: absolute;\n    width: 130px;\n    height: 64px;\n    top: 0;\n    left: ", "px;\n    padding: 5px;\n\n    > div {\n      padding: 0;\n    }\n  }\n\n  .", " {\n    border: 1px solid ", ";\n    border-radius: ", "px;\n    display: block;\n    width: 20px;\n    height: 20px;\n    position: relative;\n    left: -10px;\n\n    &::after {\n      content: '\u203A';\n      display: inline-block;\n      width: 1px;\n      position: relative;\n      left: 25px;\n      top: 9px;\n      color: ", ";\n    }\n  }\n"], ["\n  .", " {\n    border-radius: ", "px;\n    background: white;\n    box-shadow: 0 4px 8px -2px ", ", 0 0 1px ", ";\n    display: block;\n    position: absolute;\n    width: 130px;\n    height: 64px;\n    top: 0;\n    left: ", "px;\n    padding: 5px;\n\n    > div {\n      padding: 0;\n    }\n  }\n\n  .", " {\n    border: 1px solid ", ";\n    border-radius: ", "px;\n    display: block;\n    width: 20px;\n    height: 20px;\n    position: relative;\n    left: -10px;\n\n    &::after {\n      content: '\u203A';\n      display: inline-block;\n      width: 1px;\n      position: relative;\n      left: 25px;\n      top: 9px;\n      color: ", ";\n    }\n  }\n"])), types_1.TableCssClassName.CONTEXTUAL_SUBMENU, theme_1.borderRadius(), N60A, N60A, exports.contextualMenuDropdownWidth, types_1.TableCssClassName.CONTEXTUAL_MENU_ICON, N30, theme_1.borderRadius(), N90);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
//# sourceMappingURL=styles.js.map