import { __makeTemplateObject } from "tslib";
import { css } from 'styled-components';
import { borderRadius, colors, themed } from '@atlaskit/theme';
import { blockNodesVerticalMargin, akEditorTableCellMinWidth, } from '@atlaskit/editor-common';
import { akEditorCodeFontFamily, akEditorCodeBlockPadding } from '../../styles';
import { akEditorDeleteBackground, akEditorDeleteBorder, akEditorSelectedBorderSize, akEditorDeleteIconColor, } from '@atlaskit/editor-common';
export var codeBlockStyles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  .ProseMirror .code-block {\n    background: ", ";\n    font-family: ", ";\n    border: ", "px solid transparent;\n    border-radius: ", "px;\n    font-size: 14px;\n    line-height: 24px;\n    margin: ", " 0 0 0;\n    counter-reset: line;\n    display: flex;\n    min-width: ", "px;\n\n    .line-number-gutter {\n      background-color: ", ";\n      color: ", ";\n      text-align: right;\n      user-select: none;\n      padding: ", " 8px;\n      border-radius: ", "px;\n      font-size: 12px;\n      line-height: 24px;\n\n      span {\n        display: block;\n\n        &::before {\n          counter-increment: line;\n          content: counter(line);\n          display: inline-block;\n        }\n      }\n    }\n\n    .code-content {\n      color: ", ";\n      border-radius: ", "px;\n      padding: ", " 16px;\n      overflow: auto;\n      display: flex;\n      flex: 1;\n\n      pre {\n        width: 100%;\n      }\n      code {\n        display: inline-block;\n        min-width: 100%;\n        tab-size: 4;\n      }\n    }\n\n    /* We render this as a basic box in IE11 because it can't handle scrolling */\n    &.ie11 {\n      display: block;\n      .line-number-gutter {\n        display: none;\n      }\n      .code-content {\n        display: block;\n        overflow: visible;\n\n        pre {\n          width: auto;\n        }\n        code {\n          display: inline;\n        }\n      }\n    }\n  }\n\n  .ProseMirror li > .code-block {\n    margin: 0;\n  }\n\n  /* Danger when top level node */\n  .ProseMirror .danger.code-block {\n    border: ", "px solid ", ";\n    .line-number-gutter {\n      background-color: ", ";\n      color: ", ";\n    }\n\n    .code-content {\n      background-color: ", ";\n    }\n  }\n\n  /* Danger when nested node */\n  .ProseMirror .danger .code-block {\n    .line-number-gutter {\n      background-color: rgba(255, 143, 115, 0.5);\n      color: ", ";\n    }\n\n    .code-content {\n      background-color: ", ";\n      background-color: rgba(255, 189, 173, 0.5);\n    }\n  }\n"], ["\n  .ProseMirror .code-block {\n    background: ", ";\n    font-family: ", ";\n    border: ", "px solid transparent;\n    border-radius: ", "px;\n    font-size: 14px;\n    line-height: 24px;\n    margin: ", " 0 0 0;\n    counter-reset: line;\n    display: flex;\n    min-width: ", "px;\n\n    .line-number-gutter {\n      background-color: ",
    ";\n      color: ", ";\n      text-align: right;\n      user-select: none;\n      padding: ", " 8px;\n      border-radius: ", "px;\n      font-size: 12px;\n      line-height: 24px;\n\n      span {\n        display: block;\n\n        &::before {\n          counter-increment: line;\n          content: counter(line);\n          display: inline-block;\n        }\n      }\n    }\n\n    .code-content {\n      color: ", ";\n      border-radius: ", "px;\n      padding: ", " 16px;\n      overflow: auto;\n      display: flex;\n      flex: 1;\n\n      pre {\n        width: 100%;\n      }\n      code {\n        display: inline-block;\n        min-width: 100%;\n        tab-size: 4;\n      }\n    }\n\n    /* We render this as a basic box in IE11 because it can't handle scrolling */\n    &.ie11 {\n      display: block;\n      .line-number-gutter {\n        display: none;\n      }\n      .code-content {\n        display: block;\n        overflow: visible;\n\n        pre {\n          width: auto;\n        }\n        code {\n          display: inline;\n        }\n      }\n    }\n  }\n\n  .ProseMirror li > .code-block {\n    margin: 0;\n  }\n\n  /* Danger when top level node */\n  .ProseMirror .danger.code-block {\n    border: ", "px solid ", ";\n    .line-number-gutter {\n      background-color: ", ";\n      color: ", ";\n    }\n\n    .code-content {\n      background-color: ", ";\n    }\n  }\n\n  /* Danger when nested node */\n  .ProseMirror .danger .code-block {\n    .line-number-gutter {\n      background-color: rgba(255, 143, 115, 0.5);\n      color: ", ";\n    }\n\n    .code-content {\n      background-color: ", ";\n      background-color: rgba(255, 189, 173, 0.5);\n    }\n  }\n"])), themed({ light: colors.N20, dark: colors.DN50 }), akEditorCodeFontFamily, akEditorSelectedBorderSize, borderRadius(), blockNodesVerticalMargin, akEditorTableCellMinWidth, themed({
    light: 'rgba(9, 30, 66, 0.04)',
    dark: colors.DN40,
}), colors.N300, akEditorCodeBlockPadding, borderRadius(), themed({ light: colors.N800, dark: colors.DN500 }), borderRadius(), akEditorCodeBlockPadding, akEditorSelectedBorderSize, akEditorDeleteBorder, colors.R75, akEditorDeleteIconColor, akEditorDeleteBackground, akEditorDeleteIconColor, akEditorDeleteBackground);
var templateObject_1;
//# sourceMappingURL=styles.js.map